summaryrefslogtreecommitdiffstats
path: root/testModule/hooks/cmdline
diff options
context:
space:
mode:
Diffstat (limited to 'testModule/hooks/cmdline')
-rwxr-xr-xtestModule/hooks/cmdline/expand-kcl-ip.sh30
1 files changed, 23 insertions, 7 deletions
diff --git a/testModule/hooks/cmdline/expand-kcl-ip.sh b/testModule/hooks/cmdline/expand-kcl-ip.sh
index 8be1c718..9f617b09 100755
--- a/testModule/hooks/cmdline/expand-kcl-ip.sh
+++ b/testModule/hooks/cmdline/expand-kcl-ip.sh
@@ -1,20 +1,36 @@
-# fakes the cmdline to fix the ip parsing when using
-# syslinux's IPAPPEND 1 mask
+command -v warn >/dev/null || . /lib/dracut-lib.sh
+
+# fakes the cmdline to fix the ip parsing in darcut's net-lib.sh
[ -d /fake ] || mkdir /fake
# need to be a tmpfs for the hack to work
mount -t tmpfs tmpfs /fake
-# append ':hiwi:eth0:none' to the 'ip=' parameter we got
-# from syslinux's IPAPPEND 1
-sed 's/\(ip=\([0-9]\{1,3\}\.\)\{3\}[0-9]\{1,3\}:\([0-9]\{1,3\}\.\)\{3\}[0-9]\{1,3\}:\([0-9]\{1,3\}\.\)\{3\}[0-9]\{1,3\}:\([0-9]\{1,3\}\.\)\{3\}[0-9]\{1,3\}\)/\1:hiwi:eno1:none/' /proc/cmdline > /fake/cmdline
+for parameter in $(getargs ip=); do
+ local temp="$parameter:"
+ set --
+ while [ -n "$temp" ]; do
+ set -- "$@" "${temp%%:*}"
+ temp=${temp#*:}
+ done
+
+ [ -n "$1" ] && ip=$1
+ [ -n "$2" ] && server_ip=$2
+ [ -n "$3" ] && gateway_ip=$3
+ [ -n "$4" ] && net_mask=$4
+
+ warn "PXE given net configuration: ip: $ip server_ip: $server_ip gateway_ip: $gateway_ip net_mask: $net_mask"
+ local final_dracut_ip_config="$ip::$gateway_ip:$net_mask:hiwi-test-28:eno1:none"
+ warn "Final dracut ip config: $final_dracut_ip_config"
+ sed --regexp-extended "s/ip=[^ ]*/ip=$final_dracut_ip_config/g" /proc/cmdline > /fake/cmdline
+done
+
# bind mount it. Can we trust mount return codes here?
# # if so, we should check what we get in $?
mount -o bind /fake/cmdline /proc/cmdline
# check if it worked
-if ! grep 'hiwi:eth0:none' /proc/cmdline; then
- command -v warn >/dev/null || . /lib/dracut-lib.sh
+if ! grep 'hiwi-test-28:eno1:none' /proc/cmdline; then
warn 'Haxing cmdline did not work :( sad pandaz...'
fi